#ifndef __SPINS_H
#define __SPINS_H 1

#include <stdlib.h>	/* Achtung bei long<->int-Mischmasch */
#include <stdio.h>
#include <string.h>	/* strcat, strcmp, usw. */
#include <math.h>
#ifndef M_PI		/* not part of C99 */
#define M_PI           3.14159265358979323846
#endif
/* #include "spinsdef.h" */	/* define Lsize Dsize Isize etc. */
#include "config.h"
#include "sighand.h"	/* signalhandler -> ini_handler, sig1 */
#include "defs.h"
#include "modeldef.h"	/* specialy system */
#include "mem.h"

// 2016-01 better local for simplicity
//extern int	algo;	/* algorithm 0=lanzcos,1=richter,2=wenzel2x2 */
//extern int	x_p;	/* output format for |x> <=3 */
extern int      chkpt_mode;  /* setup after crash possible old: save_mode */
extern int      checkpoint; /* setup after crash possible */

/* name of the checkpoint file */
#define FCHKPT "tmp_shared/chkpt"

/* set or unset the following macros in config.h and not here
   (here we have only default values) */
/* IFz(x) produced a cpp-error on cray, so we changed it back 1998-148 */
/* ToDo: add PARAz for XXZ model */
#ifndef IFz		/* may be predefined in config.h */
#define IFz	1  	/* 1 = JJ-model, 0 = XY-JJ-model, else XXZ-model */
#endif
#ifndef NEW
#define NEW	4	/* number of lowest eigenvalues   >=NEV,>ne0 */
#endif
#if defined(NEV) && defined(CFG_FTLM) && NEV<MAX_ITR
#error NEV is to small, must be MAX_ITR
#undef NEV
#endif

#ifndef NEV
#ifdef CFG_FTLM  /* support for Finite Temperature Lanczos Method */
#define NEV   MAX_ITR  /* needed to store all tridiag-eigenvectors 2016-05 */
#else
#define NEV	1	/* max. number of eigenvectors  <=(NEW-NE0) */
#endif
#endif

#ifndef CM			/* CaseModel => config.h */
#error define CM(JJ,tJ,tU) JJ	/* default=JJ else tJ or tU model */
#endif

#ifndef N0
#define N0 NN
#endif

/* smallest type for base configurations dN..d1 uN..u1 */
/* cray: sizeof() short=int=long=longlong! but bits are different!? */
/* 1998-148: cray (short)0100=0000 (short)0080=ff80 !?
   1998-150: tbase1=1bit/site, tbase = CM ( tbase1, tbase[u,d], .. )
   2002apr: Nd,...,3d,2d,1d,Nu...,3u,2u,1u in one word
   ToDo: move to hilbert.h (tbase.h is only for l1[])
   BitsPerSite=CM(1,2,2)
   ToDo: rename tbase (more physics name) to tbits (more computer science)
       think, that "tbits" will be better undertstud by new developpers
 */
#ifndef __STDC_LIMIT_MACROS   /* defined in gcc6, but not in gcc4 2017-01-25 */
#define __STDC_LIMIT_MACROS 1 /* ISO C99 C++ wants it for UINT64_MAX */
#endif
#include <stdint.h> /* standart integer, uint64_t on gcc-m32 2015-05-11 */

#if   CM(1,2,2)*NN <= 8*S_int         /* 32bit */
  typedef unsigned int       tbase1;
# define S_tbase S_int
#elif CM(1,2,2)*NN <= 8*S_long        /* 32 or 64bit CPU+cc-dependent */
  typedef unsigned long      tbase1;
# define S_tbase S_long
#elif UINT64_MAX        &&  CM(1,2,2)*NN <= 64
/* 
  tested HP-mini Atom tU20 4 2 -2 4 6+20 n1=464 p1=1 p6=1 -11.70820390 2015-05-17
  long64: minsymcfg_lNbrk t=1.1s loops/s= 4.7e+05 t[ns]/cfs=   26.68 0 ud=6+20
  long64: minsymcfg_loopN t=1.1s loops/s= 5.9e+04 t[ns]/cfs=  211.93 0 4Ni
  uint64 == long64
  versus old vlint: (10..13 times slower)
   vlint: minsymcfg_lNbrk t=1.4s loops/s= 4.8e+04 t[ns]/cfs=  261.67 0 ud=6+20
   vlint: minsymcfg_loopN t=1.8s loops/s= 4.5e+03 t[ns]/cfs= 2796.99 0 4Ni 
   after some vlint-optimizations factor 8 (ToDo: further vlint-speedup possible)
*/
   /* test 2015-05-11 gcc412-m32 NN=40 */ 
  typedef uint64_t           tbase1;
# define S_tbase 8   /* in Bytes! */
//#elif  defined(_GLIBCXX_USE_INT128) &&  CM(1,2,2)*NN <= 128
#elif 1 && defined(__SIZEOF_INT128__) &&  CM(1,2,2)*NN <= 128 
/*  gcc4.7 -m64 ok (-m32 not, gcc44 not)
  gcc -mtune=native -dM -E -x c /dev/null | grep INT128 # __SIZEOF_INT128__ 16
  configure2015: test __int128 and set -D__SIZEOF_INT128__=16 or -DNO__int128
  tested on HP-mini Atom tU40 2015-05-17 2+38=3894 3+37=6e5(0m2) 4+36=5e7(5m++)
 __m128i: ... compile errors ... ToDo howto use 128bit-mmx-x86-registers?
    failed, getl1-alignment?
 __int128: minsymcfg_lNbrk t=1.7s loops/s= 1.5e+05 t[ns]/cfs=   41.66 0 ud=6+34
 __int128: minsymcfg_loopN t=1.1s loops/s= 7.2e+03 t[ns]/cfs=  869.83 25 4Ni
 versus old vlint: (24..90 times slower)
   vlint: minsymcfg_lNbrk t=1.4s loops/s= 2.3e+04 t[ns]/cfs=  269.36 34 ud=6+34
   vlint: minsymcfg_loopN t=2.2s loops/s= 9.2e+02 t[ns]/cfs= 6768.18 44 4Ni
*/
//#include <emmintrin.h>  /* __SSE2__ */
//  typedef __m128i            tbase1;
// ToDo: configure only? not on gcc -m32
  typedef unsigned __int128    tbase1; /* ToDo: check by configure */
# define S_tbase 16  /* Bytes! 2016-01 was 128 */
#elif 0 & defined(__SSE2__) &&  CM(1,2,2)*NN <= 128 
/*  gcc4.7 -m64 ok (-m32 not, gcc44 not)
 __m128i: ... compile errors ... ToDo howto use 128bit-mmx-x86-registers?
 src/tbase.h:39: error: incompatible types when assigning ... from type long
  int a[] __attribute__ ((aligned (16))) = {0,0,0,1};
  no shift operations on SSE2
 __m128i t = *(__m128*)a, x= __mm_XXX(t); ???  */
#include <emmintrin.h>  /* __SSE2__ */
/* direct access to 128bit registers 
  __m128 for float, __m128d for double and __m128i for int, short, char */
  typedef __m128i            tbase1;
# define S_tbase 16 /* Bytes!, 2016-01 was 128 */
# define SSE2_tbase 1  /* every tbase access needs its own __mm-functions? */
#else 
# if 0  /* old non log2 but packed, not benes compatible 2015-12 */
/* ToDo: use __uint128_t or 256bit vectorregisters if <<>>|& is defined */
/* 2015-09-23 non-log2-types do not work for benes! */
#  define B2size ( CM(1,2,2)*((NN-1)/(8*S_int)+1)) /* size in int =fastest */
#  define S_tbase (B2size * S_int)  /* usually Bsize <= (B2size*S_int) */
# endif
# if   CM(1,2,2)*NN <= 128 /* added 2015-12-31, benes needs 2^n */
# define S_tbase 16  /* Bytes!, 2016-01 was 128 */
# elif CM(1,2,2)*NN <= 256 /* added 2015-12-31, benes needs 2^n */
# define S_tbase 32  /* Bytes!, 2016-01 was 256 */
# elif CM(1,2,2)*NN <= 512 /* added 2015-12-31, benes needs 2^n */
# define S_tbase 64  /* Bytes!, 2016-01 was 128 */
# elif CM(1,2,2)*NN <= 1024 /* added 2015-12-31, benes needs 2^n */
# define S_tbase 128 /* Bytes!, 2016-01 was 128 */ 
# else
# error "needs new definitions for more than 1024 bits"
# endif
# define B2size (S_tbase / S_int)
#if (B2size * S_int) != S_tbase  
# error "S_tbase is not a multiple of S_int, fatal"
#endif
#ifdef __cplusplus
#include "vlint.h"     /* speed loss! avoid this! sets _Vlint_h = 1 */
#else
#  if   CM(1,2,2)*NN <= 128
#    error "need c++.vlint.h for bigger tbase OR gcc -D__SIZEOF_INT128__=16"
#  else
#    error "need c++.vlint.h for tbase bigger than 128 bit"
#  endif
/* ToDo: replace by functions, setzero, set/getbit, shift, ...? */
/* removed v2.38 for better MPI-compatibility, problem for gcc -m32 NN>32 */
/* use structure of bitfields ??? + setsite, getsite */
/*#  include "/dev/zero" */ /* boese! */
   typedef int_break_cc bad_syntax[##];
#endif  /* if __cplusplus */
typedef class vlint tbase1;   /* unsigned int[] */
#endif  /* CM(1,2,2)*NN does not fit into any int type, to long */
typedef tbase1 tbase;

#include "symmetry.h"	/* need declaration of tbase1 */


extern ULong  n1,n2;		/* Matrixsize , Lin table size ? */
extern int    n1_bits; /* bits needed to store n1, used for MPI packing */
extern double h_nz;    /* number of nonzero matrix elements (statistics) */
extern int	pew;		/* number eigenvalue to check    */
#ifndef CFG_FTLM  /* ~ Finite-Temperature Lanczos Method */
extern double ew[NEW];          /* eigenvalues  (max# NEW)       */
#else
extern double ew[MAX_ITR];      /* full tridiag needed */
#endif
extern FILE *f1;		/* output file			 */
extern ULong *base2;
/* ERR(600): try one of unsigned char, short, int, long, double(?) */
/*            ===========> consumes more memory  */
#ifndef ATnorm2
#define ATnorm2 unsigned char	/* range=0..255^sizeof(Tnorm2), for arrays */
#endif
#ifndef Tnorm2
#define Tnorm2 ULong  /* prefactor, default=ULong (try __int128 or double) */
#endif
extern ULong h_n1;		/* # of stored lines in hxy (obsolete)	*/
extern ULong hfmax;		/* max. number of hxy-elements on disk	*/
#if 0				/* never defined, better than comments?	*/
 extern cplx sqrt(x)cplx x;{return(pow(x,0.5));}/* only for buggy GNUC	*/
#endif

/* ------- class base_ => b_ ----------------------------------- */
/* tJ and tU still needs get_symbase and MaxSBase>1 (this is slow on MPI) */
/* symetric base structure
 * v1: buffer and results for minsymcfg function,
 * ToDo: [MaxSBase abtrennen] AH zufuegen? sbase + fullsbase[1]=Slow
 */
struct sbase{		/* memory intensive, how archive locality? [AH]! */
  tbase  scfg;		/* minsymcfg, old: b_smallest */
  Tnorm2 norm2;		/* norm^(-2),   <cfg|scfg),  N=10 S=5/2 norm2>1e9 */
  tphase sign;		/* phase, real=int=+1,-1 */
  /* ToDo: remove */
//  int    num;		/* number of configs (mostly 2*MaxSym+2) (needed?)*/
  /* ToDo: remove */
//  int    o;		/* option: 0=fullbase,1=minsymcfg,2=isminsymcfg */
  /* waste nhm space ToDo: use malloc or separate split off full_sbase */
  /* used in b_out() b_twice allsymcfg_lm allsymcfg_ud allsymcfg isminsymcfg_slow
   *         ini_norm2(DBG) xval.c.modeloverlap() stringorder[2] 
   */
};
//#if defined(CONFIG_MPI) && CM(1,0,0)
//#define MaxSBase  1  /* set to mimimum acceptable size, less debugging */
//#else
#define MaxSBase (2*MaxSym+2)	/* should be larger than 2*MaxSym+1 */
//#endif
/* full symetric base structure (2015-03-10) old: sbase
 * v1: buffer and results for minsymcfg function,
 * ToDo: [MaxSBase abtrennen] AH zufuegen? sbase + 
 *  fullsbase[1]=Slow for (slow) debugging and test
 */
struct fullsbase{	/* memory intensive, how archive locality? [AH]! */
  tbase  scfg;		/* minsymcfg, old: b_smallest */
  Tnorm2 norm2;		/* norm^(-2),   <cfg|scfg),  N=10 S=5/2 norm2>1e9 */
  tphase sign;		/* phase, real=int=+1,-1 */
  int    num;		/* number of configs (mostly 2*MaxSym+2) */
  int    o;		/* option: 0=fullbase,1=minsymcfg,2=isminsymcfg */
  /* waste nhm space ToDo: use malloc or separate split off full_sbase */
  /* used in b_out() b_twice allsymcfg_lm allsymcfg_ud allsymcfg 
   *         ini_norm2(DBG) xval.c.modeloverlap() stringorder[2] 
   * ToDo: alloc ib,is locally! to spare mem
   */
  tbase  ib[MaxSBase];	/* ib[MaxSBase] large object -> class for array proof? */
  tphase is[MaxSBase];  /* NULL if empty/unused, malloc(MaxSBase*..) needed */
};

	/* Flip(cfg,i1,i2) cfg^flip[i1][i2] last change: Apr98 JS */
#if   CM(1,0,0)
#define Flip(cfg,i1,i2) ((cfg) ^ ((tbase)1)<<(i1) ^ ((tbase)1)<<(i2))
#elif CM(0,1,1)				/* u<=>d sites i,j */
#define Flip(cfg,i1,i2) ((cfg) ^ ((tbase)3)<<((i1)*2) ^ ((tbase)3)<<((i2)*2) )
#endif

/* ToDo: alloc in dynamic way and store max needed size!?
 *       better fix for MPI_transfers (but fill with mpi*n Hlines[blk]
 * NZXMAX max# of elements of one line in a HBlock, smaller is faster
 *   see output of h_nz_x_max for a optimum value
 * NUM_AHEAD_LINES is an buffer to store H lines ahead for less MPI calls
 * 2017-01-13 64 is to bad scaling see y2016/lrzGarching*.txt AH=32K HBLen=4M
 *          1024 used now (eats more memory, p.e. 8M growed to 41MB)
 *          see plot speed/core vs. cores (using min. nodes for growing n1)
 */
#ifndef  NUM_AHEAD_LINES  /* better cache usage, but bigger buffer size */
# define NUM_AHEAD_LINES (1024)   /* must be 1 or greater, static memory! */
#endif
/* maximum number of non-zero elements per matrix line
 *   keep it as minimum to minimize buffer size (NUM_AHEAD_LINES*NZXMAX) */
#ifndef NZXMAX  /* 2015-05-11 multiple of 32 for VS-vectors at AH=1 */
# ifdef  Nw
#  ifdef  AddSS
#    define NZXMAX ((((NN/2)*(NN/2)+Nw+2)+31) & ~31)
#  else
#    define NZXMAX (((Nw+2)+31) & ~31)
#  endif
# else
#  define NZXMAX 256
# endif
#endif

/* VS is for unroll/vectorization/pipeline-filling
   optimum depends on SIMD-vector size, pipelinedepth, num ALUs etc.
   see hilbert.h table for best choice
   2016-01-09 best VS depends from NN and CM() !!! 4*64bit 20, ToDo: check!
*/
#ifndef VS                /* best use cc-option to change VS: -DVS=4 */ 
#if   defined(__AVX2__)   /* best found for HaswellEP-E5-2630v3 is VS=32 */
#define VS (32*8/S_tbase)
#elif  defined(__tune_atom__) /* best found for N455 is VS=16 but HT.VS=8 */
#define VS (8*8/S_tbase)
#else
#define VS (8*8/S_tbase)   /* best for SSE2? */
#endif
#endif
#if VS <= 0
#undef VS
#define VS 1 /* minimum VS 2016-01 */
#endif

  /* round up to multple of VS for vectorized hilbert.minsymconf... */
#define HBLrVS (((NZXMAX*NUM_AHEAD_LINES+VS-1)/VS)*VS) /* 2015-06-01 */
/* --------------- this is for pthread code ------------- 
 * all arguments needed by sub-functions to calculate |H|m> or <n|H|v0> (?)
 *  within threads are stored here
 */
typedef struct shbuf {	/* buffer to calculate a H-line H|icfg> */
  int block;		/* compute thread or vector-blockNo (0..B_NUM-1) */
  ULong i;              /* index of configuration |i> where H acts on v2.26 */
  tvec *v0;             /* vector for <nHv> (v1+=H*v0) or vnul=((tvec *)NULL) */
  tvec *v1;             /* used for geth_block v1+=H*v0 */
  struct sbase sci, scj;/* working sym-cfg space for nhv+nhm within threads */
     /* Todo: rename to scj = struct or sym cfg i+j ? old: b=base_cfg */
  tbase tcfg;           /* target config for operator functions op_xx(cfg) v2.36 */
  /* ToDo: use rx also as nhn (obsolete), when no v0 is given */
  double rx;            /* r=<v0|H|v0> incl. nHn, geth_block  */
  /* double sum_nhn; */ /* 2013-02-07 old nhn, sum diagonal elements */
  /* next two lines are for speed_test and simpler code (better+faster?) */
  tbase  cfg[NUM_AHEAD_LINES+1]; /* 2015-10-08 JS target_cfg[AHEAD] */
  int    nzx[NUM_AHEAD_LINES+1]; /* 2015-10-08 JS nzx(target_cfg)[AHEAD] */
  /* array+1 allows to store initial 0 at end without segfault, simpler code */
  double nhn[NUM_AHEAD_LINES+1];  /* diagonal element H[n,n] [AHEAD] 2013-02 */
  /* 2013-04-04 nhv from double to cplx */
  cplx   nhv[NUM_AHEAD_LINES+1];  /* 2013-02-07 diag2 _nhv sum_i H[n,i]*|v0i> */
  double rtime;           /* calculation runtime of this block,
                        for debug + benchmarks, long to dbl 2013-04 */
  /* line_start: pointer to first matrix element of the actual matrix line */
  int line_start;       /* used for puthbuf line compression for num_ahead>1 */
  int n;                /* num_stored_elements in el[] of all aheadlines */
  /* int nmax; ToDo: dyn. size of buffer?
   * ToDo: prepare for multiple-line buffering (1..100)
   *       use last entry of line as rr=<nHv0>, bj=scfg_i, jj=0 [?XY_FLAG]
   *  add num_lines=0..AH-1 + nzx[NAH]
   */
  int num_ahead_lines; /* old: num_ahead_lines=1 1..NZXMAX/max_nz_x */
  /* old struct_shelem.{bj,blkj,jj,rr}.el[NZX*NAH]
   *   wasting mem (unpacked) + bad for SIMD 2014     */
  /* struct shelem { */ /* struct[] removed 2015-04-15 for SIMD speedup */
  /* ahead buffer for i-i%num_ahead_lines... NZ-elements */
    tbase acj[HBLrVS]/* __attribute__ ((aligned (64)))*/; /* array config |j> */
    /* cfg or minsymcfg, renamed from kj v2.26 to bj 2015-04 to acj */
                  /* first element of the line must be cfg_i v2.35 */
    int   abj[HBLrVS]; /* blkj 2015-04-15 renamed to abj */
         /* block number of config j,   0..(pt_n*mpi_n-1) v2.27,
          *  ToDo2015: short up to 32k nodes! */
    ULong  jj[HBLrVS]; /* ToDo: int32 safes mem 2G/core */
    	  /* index of config |kj> 0..(b_len[blkj]-1) +XY_FLAG */
    /* 2013-04-04 mcplx to cplx avoiding problems with float16 and *=,+= */
    cplx   rr[HBLrVS];	
      /* matrix element H[x,y]=H[i,j] (v0==0) or  iHv (v0!=0) */
    /* ToDo: char para;  parameter index J1, J2 etc. */
    /* add norm2 for better wopij()??? */
  /* } el[HBLrVS]; */ /* buffer to reduce MPI traffic */
  /* 2015-04-15 add arrays asj and an2 for minsymcfg_blk */
  tphase asj[HBLrVS]/* __attribute__ ((aligned (64)))*/; /* temporary sign, better sign change flag */
  Tnorm2 an2[HBLrVS]/* __attribute__ ((aligned (64)))*/; /* temporary norm2 */
} thbuf;        /* initialize this using alloc_hbuf() */

/*  thbuf *hbuf; hbuf=alloc_hbuf(); ... free_hbuf(hbuf); */
/* ToDo: 2014-07 not needed globally anymore, main() only */
/*
 thbuf *alloc_hbuf( void );
 void  *free_hbuf( thbuf *pb );
*/


#include "symmetry.h"
static inline double norm(const double r){return(r*r);}
char *sclock(long t);
/* --------------- in-out-functions ---------------------------- */
char *outc(cplx r);  /* complex double */    

void nl(FILE *f);
void outew(FILE *f, const double *ew, const int n_ew); /* "new" = C++keyword */

/* get, store or multiply  H line i..i+nahead-1 (depends on m1) */
cplx hamilton_nhv(ULong i, ULong nahead, thbuf *hbuf, int m1);

/* v1=H*v0+v1, r=<v0|H*v0> */
double hamilton(tvec *v0, tvec *v1, thbuf *hbuf[B_NUM]);

/* void storeh(); --obsolete-- */

/* send job (function worker) to threads and restart them */
void parallel_start( int thread_i, void (*worker)(void *data), void *data );
 
/* waiting for threads OR dummy for non-threaded */
void parallel_wait( int thread_i );

#endif
/* last line should be a newline, else cray-cc prints warnings */

